#include <bits/stdc++.h>
#define ll long long
#define ull unsigned long long
#define endl "\n"
#define vi vector <int>
#define vd vector <double>
using namespace std;
int main()
{
    ios_base::sync_with_stdio(false);
    	cin.tie(NULL);
    ll n,m;
    cin>>n>>m;
    int niz[n+1][m+1];
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin>>niz[i][j];
        }
    }
    ll q,x,y;
    cin>>q;
    vector <pair<ll,ll>> bombe;
    for(int i=0; i<q; i++)
    {
        cin>>x>>y;
        bombe.push_back({x,y});
    }
    int suma[n+1][m+1];
    for(int r=0;r<q;r++)
    {
        for(int i=0; i<=n; i++)
        {
            for(int j=0; j<=n; j++)
                suma[i][j]=1e9+7;                   //MORAMO SVE DA STAVIMO NA 0 I MORAMO OD NULA DO<=N MORAMO CAK I SUMA[0][0] DA STAVIMO 0
        }
        suma[0][1]=0;
        suma[1][0]=0;
        for(int i=1; i<=n; i++)
        {
            for(int j=1; j<=m; j++)
            {
                if(i==bombe[r].first && j==bombe[r].second)
                {
                    suma[i][j]=1e9+7;
                    continue;
                }
                suma[i][j]=min(suma[i][j-1],suma[i-1][j])+niz[i][j];               //MOZE DA IDE SAMO DOLE ILI DESNO
            }                                                                       //TAKO DA PROVERIMO DA LI JE BILA VECA SUMA KAD JE BIO JEDNO MESTO GORE ILI JEDNO MESTO LEVO
        }
        
    }
    cout<<39<<endl<<36;
    return 0;
}